gtkmm: Gtk::UIManager Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions

# Gtk::UIManager Class Reference

Constructing menus and toolbars from an XML description. More...

Inheritance diagram for Gtk::UIManager:
[legend]
Collaboration diagram for Gtk::UIManager:
[legend]

List of all members.

## Public Types
typedef guint | ui_merge_id
## Public Member Functions
virtual | ~UIManager ()
GtkUIManager* | gobj ()
| Provides access to the underlying C GObject.
const GtkUIManager* | gobj () const
| Provides access to the underlying C GObject.
GtkUIManager* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_add_tearoffs (bool add_tearoffs=true)
| Sets the "add_tearoffs" property, which controls whether menus generated by this Gtk::UIManager will have tearoff menu items.
bool | get_add_tearoffs () const
| Returns whether menus generated by this Gtk::UIManager will have tearoff menu items.
void | insert_action_group (const Glib::RefPtr< ActionGroup >& action_group, int pos=0)
| Inserts an action group into the list of action groups associated with self.
void | remove_action_group (const Glib::RefPtr< ActionGroup >& action_group)
| Removes an action group from the list of action groups associated with self.
Glib::ListHandle< Glib::RefPtr < ActionGroup > > | get_action_groups ()
| Returns the list of action groups associated with self.
Glib::ListHandle< Glib::RefPtr < const ActionGroup > > | get_action_groups () const
| Returns the list of action groups associated with self.
Glib::RefPtr< AccelGroup > | get_accel_group ()
| Returns the Gtk::AccelGroup associated with self.
Glib::RefPtr< const AccelGroup > | get_accel_group () const
| Returns the Gtk::AccelGroup associated with self.
Widget* | get_widget (const Glib::ustring& path)
| Looks up a widget by following a path.
const Widget* | get_widget (const Glib::ustring& path) const
| Looks up a widget by following a path.
Glib::SListHandle< Widget* > | get_toplevels (UIManagerItemType types)
| Obtains a list of all toplevel widgets of the requested types.
Glib::SListHandle< const Widget* > | get_toplevels (UIManagerItemType types) const
| Obtains a list of all toplevel widgets of the requested types.
Glib::RefPtr< Action > | get_action (const Glib::ustring& path)
| Looks up an action by following a path.
Glib::RefPtr< const Action > | get_action (const Glib::ustring& path) const
| Looks up an action by following a path.
ui_merge_id | add_ui_from_string (const Glib::ustring& buffer)
| Parses a string containing a UI definition and merges it with the current contents.
ui_merge_id | add_ui_from_file (const Glib::ustring& filename)
| Parses a file containing a and merges it with the current contents of self.
void | add_ui (ui_merge_id merge_id, const Glib::ustring& path, const Glib::ustring& name, const Glib::ustring& action, UIManagerItemType type=Gtk::UI_MANAGER_AUTO, bool top=true)
| Adds a UI element to the current contents of self.
void | add_ui_separator (ui_merge_id merge_id, const Glib::ustring& path, const Glib::ustring& name="", UIManagerItemType type=Gtk::UI_MANAGER_AUTO, bool top=true)
| Adds a separator UI element to the current contents.
void | remove_ui (ui_merge_id merge_id)
| Unmerges the part of selfs content identified by merge_id.
Glib::ustring | get_ui () const
| Creates a of the merged UI.
void | ensure_update ()
| Makes sure that all pending updates to the UI have been completed.
ui_merge_id | new_merge_id ()
| Returns an unused merge id, suitable for use with gtk_ui_manager_add_ui().
Glib::SignalProxy1< void, Widget* > | signal_add_widget ()
| The add_widget signal is emitted for each generated menubar and toolbar.
Glib::SignalProxy0< void > | signal_actions_changed ()
| The "actions-changed" signal is emitted whenever the set of actions changes.
Glib::SignalProxy2< void, const Glib::RefPtr< Action > &, Widget* > | signal_connect_proxy ()
| The connect_proxy signal is emitted after connecting a proxy to an action in the group.
Glib::SignalProxy2< void, const Glib::RefPtr< Action > &, Widget* > | signal_disconnect_proxy ()
| The disconnect_proxy signal is emitted after disconnecting a proxy from an action in the group.
Glib::SignalProxy1< void, const Glib::RefPtr< Action >& > | signal_pre_activate ()
| The pre_activate signal is emitted just before the action is activated.
Glib::SignalProxy1< void, const Glib::RefPtr< Action >& > | signal_post_activate ()
| The post_activate signal is emitted just after the action is activated.
Glib::PropertyProxy< bool > | property_add_tearoffs ()
| Whether tearoff menu items should be added to menus.
Glib::PropertyProxy_ReadOnly < bool > | property_add_tearoffs () const
| Whether tearoff menu items should be added to menus.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_ui () const
| An XML string describing the merged UI.
## Static Public Member Functions
static Glib::RefPtr< UIManager > | create ()
## Protected Member Functions
| UIManager ()
virtual void | on_add_widget (Widget* widget)
virtual void | on_actions_changed ()
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::UIManager > | wrap (GtkUIManager* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Constructing menus and toolbars from an XML description.

A Gtk::UIManager constructs a user interface (menus and toolbars) from one or more UI definitions, which reference actions from one or more action groups.

UI Definitions

The UI definitions are specified in an XML format which can be roughly described by the following DTD.

     <!ELEMENT ui (menubar|toolbar|popup|accelerator)* >
     <!ELEMENT menubar (menuitem|separator|placeholder|menu)* >
     <!ELEMENT menu (menuitem|separator|placeholder|menu)* >
     <!ELEMENT popup (menuitem|separator|placeholder|menu)* >
     <!ELEMENT toolbar (toolitem|separator|placeholder)* >
     <!ELEMENT placeholder (menuitem|toolitem|separator|placeholder|menu)* >
     <!ELEMENT menuitem EMPTY >
     <!ELEMENT toolitem (menu?) >
     <!ELEMENT separator EMPTY >
     <!ELEMENT accelerator EMPTY >
     <!ATTLIST menubar name #IMPLIED                       action #IMPLIED >
     <!ATTLIST toolbar name #IMPLIED                       action #IMPLIED >
     <!ATTLIST popup name #IMPLIED                       action #IMPLIED >
     <!ATTLIST placeholder name #IMPLIED
                           action #IMPLIED >
     <!ATTLIST separator name #IMPLIED
                           action #IMPLIED
                           expand (true|false) #IMPLIED >
     <!ATTLIST menu name #IMPLIED
                           action #REQUIRED
                           position (top|bot) #IMPLIED >
     <!ATTLIST menuitem name #IMPLIED
                          action #REQUIRED
                          position (top|bot) #IMPLIED >
     <!ATTLIST toolitem name #IMPLIED
                          action #REQUIRED
                          position (top|bot) #IMPLIED >
     <!ATTLIST accelerator name #IMPLIED
                           action #REQUIRED >

There are some additional restrictions beyond those specified in the DTD, e.g. every toolitem must have a toolbar in its anchestry and every menuitem must have a + menubar or popup in its anchestry. Since a GMarkup parser is used to parse the UI description, it must not only be valid XML, but valid GMarkup.

If a name is not specified, it defaults to the action. If an action is not specified either, the element name is used. The name and action attributes must not contain '/' characters after parsing (since that would mess up path lookup) and must be usable as XML attributes when enclosed in doublequotes, thus they must not '"' characters or references to the " entity.

Example: UI Definition

       <ui>
       <menubar>
         <menu name="FileMenu" action="FileMenuAction">
           <menuitem name="New" action="New2Action" />
           <placeholder name="FileMenuAdditions" />
         </menu>
         <menu name="JustifyMenu" action="JustifyMenuAction">
           <menuitem name="Left" action="justify-left"/>
           <menuitem name="Centre" action="justify-center"/>
           <menuitem name="Right" action="justify-right"/>
           <menuitem name="Fill" action="justify-fill"/>
         </menu>
       </menubar>
       <toolbar action="toolbar1">
         <placeholder name="JustifyToolItems">
           <separator/>
           <toolitem name="Left" action="justify-left"/>
           <toolitem name="Centre" action="justify-center"/>
           <toolitem name="Right" action="justify-right"/>
           <toolitem name="Fill" action="justify-fill"/>
           <separator/>
         </placeholder>
       </toolbar>
       </ui>

The constructed widget hierarchy is very similar to the element tree of the XML, with the exception that placeholders are merged into their parents. The correspondence of XML elements to widgets should be almost obvious:

- menubar a Gtk::MenuBar
- toolbar a Gtk::Toolbar
- popup a toplevel Gtk::Menu
- menu a Gtk::Menu attached to a menuitem
- menuitem a Gtk::MenuItem subclass, the exact type depends on the action
- toolitem a Gtk::ToolItem subclass, the exact type depends on the action. Note that toolitem elements may contain a menu element, but only if their associated action specifies a Gtk::MenuToolButton as proxy.
- separator a Gtk::SeparatorMenuItem or Gtk::SeparatorToolItem
- accelerator a keyboard accelerator

The "position" attribute determines where a constructed widget is positioned wrt. to its siblings in the partially constructed tree. If it is "top", the widget is prepended, otherwise it is appended.

UI Merging

The most remarkable feature of Gtk::UIManager is that it can overlay a set of menuitems and toolitems over another one, and demerge them later.

Merging is done based on the names of the XML elements. Each element is identified by a path which consists of the names of its anchestors, separated by slashes. For example, the menuitem named "Left" in the example above has the path /ui/menubar/JustifyMenu/Left and the toolitem with the same name has path /ui/toolbar1/JustifyToolItems/Left.

Accelerators

Every action has an accelerator path. Accelerators are installed together with menuitem proxies, but they can also be explicitly added with <accelerator> elements in the UI definition. This makes it possible to have accelerators for actions even if they have no visible proxies.

Smart Separators

The separators created by Gtk::UIManager are "smart", i.e. they do not show up in the UI unless they end up between two visible menu or tool items. Separators which are located at the very beginning or end of the menu or toolbar containing them, or multiple separators next to each other, are hidden. This is a useful feature, since the merging of UI elements from multiple sources can make it hard or impossible to determine in advance whether a separator will end up in such an unfortunate position.

For separators in toolbars, you can set expand="true" to turn them from a small, visible separator to an expanding, invisible one. Toolitems following an expanding separator are effectively right-aligned.

Empty Menus

Submenus pose similar problems to separators inconnection with merging. It is impossible to know in advance whether they will end up empty after merging. Gtk::UIManager offers two ways to treat empty submenus:

- make them disappear by hiding the menu item they're attached to
- add an insensitive "Empty" item

The behaviour is chosen based on the "hide_if_empty" property of the action to which the submenu is associated.

Since gtkmm 2.4:

## Member Typedef Documentation

typedef guint Gtk::UIManager::ui_merge_id

## Constructor & Destructor Documentation

virtual Gtk::UIManager::~UIManager | ( |  | ) | `[virtual]`

Gtk::UIManager::UIManager | ( |  | ) | `[protected]`

## Member Function Documentation

void Gtk::UIManager::add_ui | ( | ui_merge_id | merge_id,
|  | const Glib::ustring & | path,
|  | const Glib::ustring & | name,
|  | const Glib::ustring & | action,
|  | UIManagerItemType | type = `Gtk::UI_MANAGER_AUTO`,
|  | bool | top = `true`
| ) |  |

Adds a UI element to the current contents of self.

If type is Gtk::UI_MANAGER_AUTO, GTK+ inserts a menuitem, toolitem or separator if such an element can be inserted at the place determined by path. Otherwise type must indicate an element that can be inserted at the place determined by path.

see add_ui_separator().

Since gtkmm 2.4:

Parameters:

  merge_id | The merge id for the merged UI, see gtk_ui_manager_new_merge_id().
  path | A path.
  name | The name for the added UI element.
  action | The name of the action to be proxied, if this is not a separator.
  type | The type of UI element to add.
  top | If `true`, the UI element is added before its siblings, otherwise it is added after its siblings.

ui_merge_id Gtk::UIManager::add_ui_from_file | ( | const Glib::ustring & | filename | ) |

Parses a file containing a and merges it with the current contents of self.

Since gtkmm 2.4:

Parameters:

  filename | The name of the file to parse.

Returns:
  The merge id for the merged UI. The merge id can be used to unmerge the UI with gtk_ui_manager_remove_ui(). If an error occurred, the return value is 0.

ui_merge_id Gtk::UIManager::add_ui_from_string | ( | const Glib::ustring & | buffer | ) |

Parses a string containing a UI definition and merges it with the current contents.

An enclosing <ui> element is added if it is missing.

Parameters:

  buffer | the string to parse

Returns:
  The merge id for the merged UI. The merge id can be used to unmerge the UI with remove_ui(). If an error occurred, the return value is 0.

Exceptions:

  exception |

Since gtkmm 2.4:

void Gtk::UIManager::add_ui_separator | ( | ui_merge_id | merge_id,
|  | const Glib::ustring & | path,
|  | const Glib::ustring & | name = `""`,
|  | UIManagerItemType | type = `Gtk::UI_MANAGER_AUTO`,
|  | bool | top = `true`
| ) |  |

Adds a separator UI element to the current contents.

If type is Gtk::UI_MANAGER_AUTO, GTK+ inserts a menuitem, toolitem or separator if such an element can be inserted at the place determined by path . Otherwise type must indicate an element that can be inserted at the place determined by path.

See also:
  add_ui().

Since gtkmm 2.4:

Parameters:

  merge_id | The merge id for the merged UI, see gtk_ui_manager_new_merge_id().
  path | A path.
  name | The name for the added UI element.
  type | The type of UI element to add.
  top | If `true`, the UI element is added before its siblings, otherwise it is added after its siblings.

static Glib::RefPtr<UIManager> Gtk::UIManager::create | ( |  | ) | `[static]`

void Gtk::UIManager::ensure_update | ( |  | ) |

Makes sure that all pending updates to the UI have been completed.

This may occasionally be necessary, since Gtk::UIManager updates the UI in an idle function. A typical example where this function is useful is to enforce that the menubar and toolbar have been added to the main window before showing it: |[ gtk_container_add (GTK_CONTAINER (window), vbox); g_signal_connect (merge, "add-widget", G_CALLBACK (add_widget), vbox); gtk_ui_manager_add_ui_from_file (merge, "my-menus"); gtk_ui_manager_add_ui_from_file (merge, "my-toolbars"); gtk_ui_manager_ensure_update (merge); gtk_widget_show (window); ]|

Since gtkmm 2.4:

Glib::RefPtr<AccelGroup> Gtk::UIManager::get_accel_group | ( |  | ) |

Returns the Gtk::AccelGroup associated with self.

Since gtkmm 2.4:

Returns:
  The Gtk::AccelGroup.

Glib::RefPtr<const AccelGroup> Gtk::UIManager::get_accel_group | ( |  | ) | const

Returns the Gtk::AccelGroup associated with self.

Since gtkmm 2.4:

Returns:
  The Gtk::AccelGroup.

Glib::RefPtr<Action> Gtk::UIManager::get_action | ( | const Glib::ustring & | path | ) |

Looks up an action by following a path.

See gtk_ui_manager_get_widget() for more information about paths.

Since gtkmm 2.4:

Parameters:

  path | A path.

Returns:
  The action whose proxy widget is found by following the path, or `0` if no widget was found.

Glib::RefPtr<const Action> Gtk::UIManager::get_action | ( | const Glib::ustring & | path | ) | const

Looks up an action by following a path.

See gtk_ui_manager_get_widget() for more information about paths.

Since gtkmm 2.4:

Parameters:

  path | A path.

Returns:
  The action whose proxy widget is found by following the path, or `0` if no widget was found.

Glib::ListHandle< Glib::RefPtr<ActionGroup> > Gtk::UIManager::get_action_groups | ( |  | ) |

Returns the list of action groups associated with self.

Since gtkmm 2.4:

Returns:
  A List of action groups. The list is owned by GTK+ and should not be modified.

Glib::ListHandle< Glib::RefPtr<const ActionGroup> > Gtk::UIManager::get_action_groups | ( |  | ) | const

Returns the list of action groups associated with self.

Since gtkmm 2.4:

Returns:
  A List of action groups. The list is owned by GTK+ and should not be modified.

bool Gtk::UIManager::get_add_tearoffs | ( |  | ) | const

Returns whether menus generated by this Gtk::UIManager will have tearoff menu items.

Since gtkmm 2.4:

Returns:
  Whether tearoff menu items are added.

Glib::SListHandle<const Widget*> Gtk::UIManager::get_toplevels | ( | UIManagerItemType | types | ) | const

Obtains a list of all toplevel widgets of the requested types.

Since gtkmm 2.4:

Parameters:

  types | Specifies the types of toplevel widgets to include. Allowed types are Gtk::UI_MANAGER_MENUBAR, Gtk::UI_MANAGER_TOOLBAR and Gtk::UI_MANAGER_POPUP.

Returns:
  A newly-allocated SList of all toplevel widgets of the requested types. Free the returned list with Glib::slist_free().

Glib::SListHandle<Widget*> Gtk::UIManager::get_toplevels | ( | UIManagerItemType | types | ) |

Obtains a list of all toplevel widgets of the requested types.

Since gtkmm 2.4:

Parameters:

  types | Specifies the types of toplevel widgets to include. Allowed types are Gtk::UI_MANAGER_MENUBAR, Gtk::UI_MANAGER_TOOLBAR and Gtk::UI_MANAGER_POPUP.

Returns:
  A newly-allocated SList of all toplevel widgets of the requested types. Free the returned list with Glib::slist_free().

Glib::ustring Gtk::UIManager::get_ui | ( |  | ) | const

Creates a of the merged UI.

Since gtkmm 2.4:

Returns:
  A newly allocated string containing an XML representation of the merged UI.

Widget* Gtk::UIManager::get_widget | ( | const Glib::ustring & | path | ) |

Looks up a widget by following a path.

The path consists of the names specified in the XML description of the UI. separated by '/'. Elements which don't have a name or action attribute in the XML (e.g. <popup>) can be addressed by their XML element name (e.g. "popup"). The root element ("/ui") can be omitted in the path.

Note that the widget found by following a path that ends in a <menu> element is the menuitem to which the menu is attached, not the menu itself.

Also note that the widgets constructed by a ui manager are not tied to the lifecycle of the ui manager. If you add the widgets returned by this function to some container or explicitly ref them, they will survive the destruction of the ui manager.

Since gtkmm 2.4:

Parameters:

  path | A path.

Returns:
  The widget found by following the path, or `0` if no widget was found.

const Widget* Gtk::UIManager::get_widget | ( | const Glib::ustring & | path | ) | const

Looks up a widget by following a path.

The path consists of the names specified in the XML description of the UI. separated by '/'. Elements which don't have a name or action attribute in the XML (e.g. <popup>) can be addressed by their XML element name (e.g. "popup"). The root element ("/ui") can be omitted in the path.

Note that the widget found by following a path that ends in a <menu> element is the menuitem to which the menu is attached, not the menu itself.

Also note that the widgets constructed by a ui manager are not tied to the lifecycle of the ui manager. If you add the widgets returned by this function to some container or explicitly ref them, they will survive the destruction of the ui manager.

Since gtkmm 2.4:

Parameters:

  path | A path.

Returns:
  The widget found by following the path, or `0` if no widget was found.

GtkUIManager* Gtk::UIManager::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

const GtkUIManager* Gtk::UIManager::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkUIManager* Gtk::UIManager::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gtk::UIManager::insert_action_group | ( | const Glib::RefPtr< ActionGroup >& | action_group,
|  | int | pos = `0`
| ) |  |

Inserts an action group into the list of action groups associated with self.

Actions in earlier groups hide actions with the same name in later groups.

Since gtkmm 2.4:

Parameters:

  action_group | The action group to be inserted.
  pos | The position at which the group will be inserted.

ui_merge_id Gtk::UIManager::new_merge_id | ( |  | ) |

Returns an unused merge id, suitable for use with gtk_ui_manager_add_ui().

Since gtkmm 2.4:

Returns:
  An unused merge id.

virtual void Gtk::UIManager::on_actions_changed | ( |  | ) | `[protected, virtual]`

virtual void Gtk::UIManager::on_add_widget | ( | Widget* | widget | ) | `[protected, virtual]`

Glib::PropertyProxy<bool> Gtk::UIManager::property_add_tearoffs | ( |  | ) |

Whether tearoff menu items should be added to menus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::UIManager::property_add_tearoffs | ( |  | ) | const

Whether tearoff menu items should be added to menus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gtk::UIManager::property_ui | ( |  | ) | const

An XML string describing the merged UI.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::UIManager::remove_action_group | ( | const Glib::RefPtr< ActionGroup >& | action_group | ) |

Removes an action group from the list of action groups associated with self.

Since gtkmm 2.4:

Parameters:

  action_group | The action group to be removed.

void Gtk::UIManager::remove_ui | ( | ui_merge_id | merge_id | ) |

Unmerges the part of selfs content identified by merge_id.

Since gtkmm 2.4:

Parameters:

  merge_id | A merge id as returned by gtk_ui_manager_add_ui_from_string().

void Gtk::UIManager::set_add_tearoffs | ( | bool | add_tearoffs = `true` | ) |

Sets the "add_tearoffs" property, which controls whether menus generated by this Gtk::UIManager will have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

Since gtkmm 2.4:

Parameters:

  add_tearoffs | Whether tearoff menu items are added.

Glib::SignalProxy0< void > Gtk::UIManager::signal_actions_changed | ( |  | ) |

The "actions-changed" signal is emitted whenever the set of actions changes.

Prototype:
  `void on_my_actions_changed()`

Glib::SignalProxy1< void,Widget* > Gtk::UIManager::signal_add_widget | ( |  | ) |

The add_widget signal is emitted for each generated menubar and toolbar.

It is not emitted for generated popup menus, which can be obtained by get_widget().

Parameters:

  widget | the added widget

Prototype:
  `void on_my_add_widget(Widget* widget)`

Glib::SignalProxy2< void,const Glib::RefPtr<Action>&,Widget* > Gtk::UIManager::signal_connect_proxy | ( |  | ) |

The connect_proxy signal is emitted after connecting a proxy to an action in the group.

This is intended for simple customizations for which a custom action class would be too clumsy, e.g. showing tooltips for menuitems in the statusbar.

Parameters:

  action | the action
  widget | the proxy

Prototype:
  `void on_my_connect_proxy(const Glib::RefPtr<Action>& action, Widget* widget)`

Glib::SignalProxy2< void,const Glib::RefPtr<Action>&,Widget* > Gtk::UIManager::signal_disconnect_proxy | ( |  | ) |

The disconnect_proxy signal is emitted after disconnecting a proxy from an action in the group.

Parameters:

  action | the action
  widget | the proxy

Prototype:
  `void on_my_disconnect_proxy(const Glib::RefPtr<Action>& action, Widget* widget)`

Glib::SignalProxy1< void,const Glib::RefPtr<Action>& > Gtk::UIManager::signal_post_activate | ( |  | ) |

The post_activate signal is emitted just after the action is activated.

This is intended for applications to get notification just after any action is activated.

Parameters:

  action | the action

Prototype:
  `void on_my_post_activate(const Glib::RefPtr<Action>& action)`

Glib::SignalProxy1< void,const Glib::RefPtr<Action>& > Gtk::UIManager::signal_pre_activate | ( |  | ) |

The pre_activate signal is emitted just before the action is activated.

This is intended for applications to get notification just before any action is activated.

Parameters:

  action | the action

Prototype:
  `void on_my_pre_activate(const Glib::RefPtr<Action>& action)`

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::UIManager > wrap | ( | GtkUIManager * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/uimanager.h